(function ($) {
    $(document).ready(function () {
        'use strict';
        $('html').removeClass('no-js');

        let transition = 0;
        const transitionStep = 100;
        const length = 5;
        const answers = $('.quiz .body');
        const answersWrap = $('.quiz .questions');
        const quizProgressElement = $('.quiz .progress__filled');
        const quizProgressStep = 100 / (length + 1);
        let quizProgressWidth = 0;
        let querystring;

        $('input[name="answer"]').on('change', nextQuestion);
        $('.quiz .button__next').on('click touch', nextQuestion);

        jQuery(document).ready(function () {
            setTimeout(() => {
                //querystring = getQueryString();
                //sendImpression(querystring);
            }, 1000)
        });

        function showReview() {
            $('.quiz .loading__analyzing').css('display', 'none');
            $('.quiz .loading').css('display', 'none');
			$('.quiz .description__analyze').removeClass('description__analyze').text('Success! We have selected profiles in accordance with your preferences. There are too many girls on our dating site and almost all of them want sex. Try to pay attention to everyone who writes to you');
            $('.quiz .review__rating .stars__filled').css('width', '9.8' * 10 + '%');
            $('.quiz .review').css('display', 'flex');
            setParamsToButton(querystring);
        }

        function showLoading() {
            const randomDelay = getRandom(2, 6);
            const bar = $('.quiz .loading__bar');
            const loadingTextElement = $('.quiz .loading__analyzing span');
            let loadingText = 0;
            const addToLoadText = 100 / (randomDelay * 2);

            const interval = setInterval(function () {
                loadingText = Math.floor(loadingText + addToLoadText);
                if (loadingText > 100) {
                    clearInterval(interval);
                    loadingText = 100;
                }
                bar.css('width', loadingText + '%');
                loadingTextElement.text(loadingText);

                if (loadingText === 100) {
                    setTimeout(showReview, 1000);
                }
            }, 500)
        }

        function nextQuestion() {
            transition -= transitionStep;
            setTimeout(function () {
                answers.css('transform', 'translateX(' + transition +'%)');

                quizProgressWidth += quizProgressStep;
                if (transition + transitionStep === length * -transitionStep) {
                    showLoading();
                    quizProgressWidth = 100;
                }
                quizProgressElement.css('width', quizProgressWidth + '%');
                checkScroll();
                window.scrollTo(0, 0);
            }, 200);
        }

        function checkScroll() {
            if ($(document).width() < 540) {
                const currentQuestionHeight = $(answers[transition / -transitionStep]).height();
                if (currentQuestionHeight > answersWrap.height()) {
                    answersWrap.css('height', currentQuestionHeight + 'px');
                }
            }
        }

        function getRandom(min, max) {
            return Math.random() * (max - min) + min;
        }

        function setParamsToButton(querystring) {
            jQuery('a[href*="/go/"]').each(function () {
                const $this = jQuery(this);
                let link = $this.attr('href');
                if (link.includes('?')) {
                    link = link.replace('?', querystring);
                } else {
                    link += querystring;
                }
                $this.attr('href', link);
            });
        }

        function getCookie(name) {
            const matches = document.cookie.match(new RegExp(
                "(?:^|; )" + name.replace(/([\.$?*|{}\(\)\[\]\\\/\+^])/g, '\\$1') + "=([^;]*)"
            ));
            return matches ? decodeURIComponent(matches[1]) : undefined;
        }

        function setCookie(name, value, options) {
            options = options || {};

            let expires = options.expires;

            if (typeof expires == "number" && expires) {
                const d = new Date();
                d.setTime(d.getTime() + expires * 1000);
                expires = options.expires = d;
            }
            if (expires && expires.toUTCString) {
                options.expires = expires.toUTCString();
            }

            value = encodeURIComponent(value);

            let updatedCookie = name + "=" + value;

            for (const propName in options) {
                updatedCookie += "; " + propName;
                let propValue = options[propName];
                if (propValue !== true) {
                    updatedCookie += "=" + propValue;
                }
            }

            document.cookie = updatedCookie;
        }
  });
})(jQuery);